
from re import findall, VERBOSE



def exo2():
    """
    Proposer une fonction qui prend en paramètre une chaine de caractère
    et transforme cette chaine de caractère en ajoutant une majuscule au début de chaque mot.
    """


    def CapitalizeSentence(s):
        """
        L'idée quand on a un problème comme ça à résoudre est de découper le problème en sous problèmes plus simples.
        
        Ici on doit :
            - 1) Découper une str représentant une phrase en liste de mots --> On utilise la méthode split.
            - 2) Pour chaque mot remplacer l'initiale par une majuscule --> On utilise la méthode capitalize.
            - 3) Reconstruire une phrase à partir d'une liste de mots --> On utilise la méthode join.
        


        Rappel :
        
        - Split est une méthode des str qui sert à séparer une chaîne de caractère. Elle s'appelle sur la chaîne à séparer, prend en argument un motif et renvoie la liste des sous-chaînes qui sont séparées par le motif. Par défaut, le motif est " " (Une espace).
        - Join est une méthode des str qui est exactement la fonction réciproque, au sens mathématique du terme. Elle s'appelle sur un motif, prend en argument une liste de sous-chaînes, et reconstruit une chaîne de caractères possédant les mots de la liste séparés par le motif.
        """

        L = s.split() # Liste des mots. Produit le même résultat que findall(r"\S*", s).
        for i, mot in enumerate(L): # Ça me permet de vous rappeler l'existence et l'utilité de enumerate
            L[i] = mot.capitalize()
        return " ".join(L) # On reconstruit la phrase.
        


    s = "l'objectif est de trouver dans un texte non"
    print(CapitalizeSentence(s))


    
def exo3():
    """
    Proposez une fonction qui double tous les nombres entiers isolés présents dans une chaîne de caractères.
    """

    def doubleEntiers(s):
        """
        On applique la même méthode : On découpe en sous problèmes plus simples.
        
        1) On découpe en liste de mots.
        2) Pour chaque mot, on teste si c'est un chiffre entier. Si oui, on le double.

            2.1 - Tester si un mot est un entier.
              --> On va utiliser la méthdode isdigit. L'intérêt c'est que les float ne sont pas
               detectés puisqu'ils contiennent un séparateur décimal (.) !
               
        /!\ Attention, les mots sont des chaînes de caractères, donc il faut faire attention.
    
            2.2 - Transformer une chaîne représentant un entier, en véritable entier.
               --> On va utiliser la fonction int. De manière générale en python, pour transformer un objet d'un type A en un type B on peut appeler B(objet). Si la traduction de types est possible, tout marche, sinon ça renvoit une erreur. Il faudra peut-être alors implémenter cette traduction de type.
       
            2.3 - Doubler un entier
            2.4 - Transformer un entier en chaîne de caractères --> idem que 2.2, on utilise str.
    
        3) Reconstruire la phrase.
        """

        L = s.split()
        for i, mot in enumerate(L):
            if mot.isdigit():
                L[i] = str(2*int(mot))
        return " ".join(L)


    s = "3 kg 12 euros. 0.25 melon, 1 euros. Par contre mon3."

    print(doubleEntiers(s))




def exo4():
    """
    Proposez une fonction qui à partir d'une longue chaîne s (>100 caractères) renvoie une liste de chaînes de caractères contenant chacune 24 caractères maximum et terminant par une espace (On ne doit pas couper les mots et la chaîne initiale doit rester la concaténation exacte de toutes les chaînes du tableau : Ne pas rajouter d'espaces artificiels !).

    Afficher ces chaînes ligne par ligne.



    Je propose 2 méthodes.
    """

    def decoupe24Carac(s):
        """
        L'idée encore une fois est de décomposer en problèmes plus simples.
        Ici, on veut découper une chaîne en mots d'au plus 24 caractères.
        
           1) Découper une phrase en mots.
           2) Reconstruire des sous chaînes d'au plus 24 caractères (espace final compris).

        On va utiliser une variable res qui stockera une liste de sous-chaînes intermédiaires.

        À chaque étape de la boucle, res contient une liste de mots de s formant des sous-chaînes d'au plus 24 caractères (espace final compris).

        On vérifie que la propriétés suivante est /Invariante/ tout au long de la boucle :

            - res contient une liste de mots de s groupés en chaînes d'au plus 24 caractères et possédant une espace terminale.
            - La concaténation des chaînes de res avec le reste des mots de l qu'on n'a pas déja lu redonne entièrement s.
        """
        L = s.split()
        res, groupe = [], ""
        for mot in L:
            if len(groupe) + len(mot) + 1 <= 23: # si on peut rajouter le prochain mot + une espace au groupe
                groupe += mot+" " # on rajoute mot et l'espace au groupe
            else: # Sinon le groupe est complet, on l'ajoute au resultat et on réinitialise.
                res.append(groupe)
                groupe = mot+" "
        # On n'oublie pas de rajouter le dernier groupe.
        res.append(groupe)
        return res

    s = "Proposez une fonction qui à partir d'une longue chaîne s (>100 caractères) renvoie une liste de chaînes de caractères contenant chacune 24 caractères maximum et terminant par un espace (on ne doit pas couper les mots et la chaîne initiale doit rester la concaténation exacte de toutes les chaînes du tableau : ne rajoutez pas d'espace artificiel !). "


    L = decoupe24Carac(s)

    # La consigne était d'afficher les groupes ligne par ligne :
    for groupe in L:
        print(groupe)


    def deuxiemeMethode(s):
        """
        La deuxième méthode consiste à utiliser les expressions régulières pour récupérer des ensembles d'au plus 23 caractères, et terminant par une espace. De sorte qu'on sera certains de ne pas couper les mots !
        En revanche, c'est une méthode complètement adhoc à l'exercice.

        J'ai importé findall au début de ce ficher de correction. Pas besoin de l'importer à chaque appel !
        """
        L = findall(r".{,23}\s", s)
        for groupe in L:
            print(groupe)
    
    print("\n\n\nDeuxième méthode !\n")
    deuxiemeMethode(s)

def exo5():
    """
    Ecrivez une fonction qui retourne True ou False, selon si la chaîne de caractère fournie est la première ligne d'une déclaration de fonction bien formée en python.
    """
    def fonctionBienFormee(s):
        """
        Pour cet exo, pas de miracle. Il faut trouver une expression régulière qui décrit une fonction bien formée, et vérifier que la sous-chaîne filtrée par le motif est la chaîne entière.


        Une déclaration de fonction en python est de la forme :

        def unChouetteNomDeFonction(monTupleDarguments) PotentiellementDesEspaces :


        Quels sont les noms de fonctions autorisées ?

        Pour le savoir, on va aller lire la documentation : 
           "Dans l'intervalle ASCII (U+0001..U+007F), les caractères licites pour les identifiants sont les mêmes que pour Python 2.x : les lettres minuscules et majuscules de A à Z, le souligné (ou underscore) _ et, sauf pour le premier caractère, les chiffres de 0 à 9."

        La documentation dit aussi 

            "Python 3.0 introduit des caractères supplémentaires en dehors de l'intervalle ASCII (voir la PEP 3131). Pour ces caractères, la classification utilise la version de la « base de données des caractères Unicode » telle qu'incluse dans le module unicodedata." 


        On va ignorer ce cas compliqué.


        Pour simplifier, on va aussi ignorer les définitions de fonction "En une ligne" comme par exemple 

        def dummyFunction(blabla): pass

        qui est censée être une définition licite de fonction (C'est beaucoup plus compliqué car il faut que ce qu'il y ait après les : soit du python bien formé .... et ça, ce n'est pas possible de faire avec les expressions rationnelles. Il faut un formalisme plus général (même pour les expressions régulières de Python qui sont déjà très générales) qu'on appelle les grammaires algébriques, mais je ne vais pas rentrer dans les détails !)


        Pour les arguments :


        On autorise les mêmes noms de variables que pour les fonctions, c'est parfait.

        
        Normalement en python, on peut aussi faire des arguments par défaut qui sont de la forme "monArgument=ValeurParDefaut", mais ceux-ci ne peuvent arriver qu'à la fin de la liste d'arguments.
        On peut aussi faire des arguments positionnels non explicites de la forme "*args" et des arguments nommés de la forme "**kwargs".


        On va ignorer toutes ces subtilités.


        On récapitule :

        Une déclaration de fonction c'est : 

        "def" + Un nom contenant des lettres majuscules ou minuscules, des _, des chiffres Sauf pour le premier caractère, et il faut que le nom comporte au moins un caractère.
        
        Ensuite, ce nom est suivi d'une parenthèse ouvrante "(", d'une liste d'arguments, d'une parenthèse fermante ")", d'un nombre quelconque d'espaces, et enfin de :
        """
        
        l = findall("""
        (              # Il faut faire attention, findall récupère des groupes
        def            # Le premier def
        \s+            # Au moins une espace
        [a-zA-Z_]+     # Début du nom : Ça ne peut pas être un chiffre.
        [a-zA-Z0-9_]*  # Suite du nom, on a éventuellement des chiffres à partir d'un certain moment.
        \s*            # Eventuellement des espaces
        \(             # Parenthèse ouvrante (précédée d'un \ pour ne pas confondre avec un groupe)
        (              # Début du groupe des arguments.
        [a-zA-Z_]+     
        [a-zA-Z0-9_]*  
        )              # Fin du groupe des arguments.
        ?              # Il peut y avoir 0 ou 1 argument, donc on met ?
        \)             # Parenthèse fermante
        \s*            # Des espaces
        :              # Le : final
        )              # La fin de la déclaration du groupe
        """.format(motifNom),s, VERBOSE) 


        # Petite explication, ici le VERBOSE sert juste à dire à Python de m'autoriser à mettre des commentaires dans mon expression pour la rendre plus lisible.

        return l



    # Ici, on a plusieurs groupes. findall va retourner une liste de tuples représentant tous les groupes qu'il a récupérés, ordonnés du plus extérieur au plus intérieur.
    # D'où l'intérêt d'avoir défini un groupe externe pour toute l'expression régulière.


    print("\n\nQuelques exemples :\n")

    
    fonction1 = "def func(monArgument):"   # On va matcher le groupe externe représentant toute la chaîne, ainsi que le groupe interne des arguments, ici monArgument
    fonction2 = "def __func2()           :" # On va matcher le groupe externe représentant toute la chaîne, ainsi que le groupe interne des arguments, ici la chaîne vide
    pasFonction1 = "def func()" # On a oublié le : final, findall renvoie une liste vide !
    pasFonction2 = "def func(monArgument): def __func2():" # La chaîne est plus longue qu'une déclaration de fonction valide. findall trouvera 2 correspondances, avec chacune 2 groupes.
    pasFonction3 = "def func(monArgument): frewgwregewrg" # La chaîne est plus longue qu'une déclaration de fonction valide, mais findall ne trouvera qu'une correspondance valide, avec 2 groupes.

    
    for x in [fonction1, fonction2, pasFonction1, pasFonction2, pasFonction3]:
        print(fonctionBienFormee(x))


    # Pour tester si la chaîne est bien une déclaration de fonction, on va donc vérifier que : 
    #          1) La liste des correspondances contient un unique couple.
    #          2) Le premier élément du couple (ie le groupe le plus externe) est égal à la chaîne complète.

    def testFonctionBienFormee(s):
        l = fonctionBienFormee(s)
        if len(l) != 1:
            return False
        else:
            return l[0][0] == s

    print("\nOn vérifie\n")

    for x in [fonction1, fonction2, pasFonction1, pasFonction2, pasFonction3]:
        if testFonctionBienFormee(x):
            print("- {}\nest la première ligne d'une déclaration de fonction en python !\n".format(x))
        else:
            print("- {}\nn'est pas valide !\n".format(x))


def exo6():
    """
    Écrivez une fonction qui détecte dans un texte tous les mots qui contiennent au moins un chiffre.
    """
    
    def auMoinsUnChiffre(s):
        """
        On peut découper le problème en problèmes plus simples :
           1) Récupérer tous les mots d'un texte.
           2) Filtrer ceux qui contiennent au moins un chiffre.
        """
        l = s.split() # Liste de tous les mots.
        res = [] # Possèdera la liste des mots qui possèdent au moins un chiffre.
        
        def contientChiffre(mot):
            """
            Parcourt un mot lettre par lettre. 
               - Renvoie True dès qu'il voit un chiffre, 
               - False s'il n'en voit aucun.
            """
            for lettre in mot:
                if lettre.isdigit():
                    return True
            return False
        
        for mot in l:
            if contientChiffre(mot):
                res.append(mot)
        return res

    s = "Hum, nous ne parveno4ns pas à trouver ce 5 site. Impossible de se connecter au serveur à l’adresse www.our43alou.fr. Si l’adresse est correcte, voici trois autres choses que vous pouvez essayer de faire : Réessayer ultérieurement. Vérifier votre connexion au réseau. Si vous êtes connecté au travers d’un pare-feu, vérifier que Firefox a la permission d’accéder au W"

    print(auMoinsUnChiffre(s))
        


    print("\nOn peut aussi utiliser les expressions régulières\n")
    
    def motsAvecAuMoinsUnChiffre(s):
        """
        L'idée est d'utiliser une expression régulière qui récupère tous les mots contenant au moins un chiffre.
        Un mot est une suite de caractères ne comportant pas de blancs.
        On se rappelle que findall va chercher des éléments maximaux parmi ceux qui correspondent à un motif. Un mot est alors un élément maximal ne comportant pas de blancs : En effet, si on peut continuer la lecture sans blanc, alors on est encore dans le mot, et un mot ne contient pas de blancs.
        Autrement dit, la liste des mots est donc findall(r"\S+").

        On souhaite de plus que les mots contiennent au moins un chiffre, ie qu'ils contiennent le motif [0-9].

        Par conséquent, un mot avec au moins un chiffre est un élément correspondant à la fois à \S+ et à .*[0-9].* : Le motif associé est donc \S*[0-9]\S*



        /!\ Remarque : Cette méthode va bien plus vite que la méthode précédente, et sur les longs textes elle serait à préférer (À raffiner selon le type d'expression qu'on veut).
        """

        return findall(r"\S*[0-9]\S*", s)

    print("Un mot avec au moins un chiffre est un élément maximal correspondant au motif \S*[0-9]\S*")
    print(motsAvecAuMoinsUnChiffre(s))
